;*********************************************
;* water level sensor sender BY FRESH NELLY! *
;*********************************************
LIST P=16C57
; PWM OUTPUT =  ,OUTPUT LOGIC 1 IS 75% DUTY,LOGIC 0 IS 50% DUTY
;1 START BIT 8 DATA BITS. INCOMPLETE READ BY DISPLAY PIC CAN BE
;SENSED IF COUNT ISN'T 9 PULSES (DISPLAY PIC SLEEPS AS WELL UNTIL TOCK ACTIVE BY USER)
;REEDS INPUT PORTB,0-7,TEST LEDS OUT PORTC,0-7
;pwm output(A,0) turns on pull down Q on power wire, sensed by level display pic
;WDT BIT ON,CP OFF
;FRQ=3.579545 MHZ ~ 1.1174605 uS/INSTR
INDF     EQU     0X00
RTCC     EQU     0X01
PCL      EQU     0X02
STATUS   EQU     0X03
FSR      EQU     0X04
PORTA    EQU     0X05
PORTB    EQU     0X06
PORTC    EQU     0X07
ROTBUF   EQU     0X08
TEMP     EQU     0X09
W        EQU     0X0A
TIMER0   EQU     0X0B
TIMER1   EQU     0X0C
SSTATUS  EQU     0X0D
BITCNT   EQU     0X0E
RDBUF2   EQU     0X0F




;
;INIT
	ORG     07FF	;POWER UP
	NOP
	ORG     0X00
	BSF	SSTATUS,0
	GOTO	START	;*****TEMP TEMP!
	;BTFSC	STATUS,3 ;SLEEP FLAGS, SET IF POWER ON RESET
	;GOTO	START
	;BTFSC	STATUS,4	;
	;GOTO	START
	GOTO	WAKE
	
START   	;enable wdt off rc osc and /128 to give 2.3 sec sleep
		;nov2007: Shouldn't 18ms be enough???
	MOVLW 	B'00101111' 
	;OPTION

	MOVLW	0X00
	TRIS	PORTB
	MOVWF	PORTB
	MOVLW	0X0F
	TRIS	PORTA
	MOVLW	0XFF
	TRIS	PORTC
	CLRF	TIMER0
	CLRF	TIMER1
	MOVLW	0X01
	MOVWF	PORTB
	MOVWF	ROTBUF
SPLASH	
	NOP
	DECFSZ	TIMER0
	GOTO	SPLASH
	DECFSZ	TIMER1
	GOTO	SPLASH
	RLF	PORTB
	INCF	ROTBUF
	BTFSS	ROTBUF,4
	GOTO	SPLASH
	CLRF	PORTB
	
WAKE	BTFSS	PORTA,0
	GOTO	RX
	BTFSS	PORTA,1	;button
	GOTO	START	;TEMP

	
	

SLP	;SLEEP
	GOTO	WAKE
RX	CLRF	TIMER0
	CLRF	BITCNT
	CLRF	ROTBUF
RXLP1	NOP
	NOP
	BTFSC	PORTA,0	;START BIT 1
	GOTO	RXDAT
	DECFSZ	TIMER0
	GOTO	RXLP1
BAD	GOTO	SLP	;FOR NOW, BAD DATA/SHORT

RXDAT	;RX'S DATA BASED ON FALLING EDGE AND COUNTS LEN OF PULSE (1 OR 0
	;AND COUNTS EACH BIT, IF NOT 8 THEN DISREGARD DATA
	CLRF	TIMER0
HILP	DECFSZ	TIMER0	;1
	GOTO	HIWT
	GOTO	BAD
HIWT	BTFSC	PORTA,0
	GOTO	HILP	;6
	INCF	BITCNT
	BCF	STATUS,0
	RLF	ROTBUF
	MOVLW	0XF0
	MOVWF	TIMER0	;ENSURE SEPARATION BETWEEN 1&0
PWM	NOP
	NOP
LOLP	
	DECFSZ	TIMER0	;1
	GOTO	LOWT
	BSF	ROTBUF,0	;SET BIT THAT IS LONG"1"
		
LOWT	BTFSS	PORTA,0
	GOTO	LOLP	;6
	CLRF	TIMER0
	BTFSS	BITCNT,3
	GOTO	RXLP1
	MOVF	ROTBUF,W
	MOVWF	PORTB
	GOTO	WAKE
	

;xSEND
;	;SEND DATA PWM
;	MOVF	RDBUF2,W
;	CALL	TABLE1
;	MOVWF	ROTBUF
;	
;	MOVLW	0X08
;	MOVWF	TIMER1	
;	RRF	ROTBUF
;
;	CALL	BIT1	;STARTBIT
;LP	RLF	ROTBUF
;	BTFSS	ROTBUF,7
;	CALL	BIT0
;	BTFSC	ROTBUF,7
;	CALL	BIT1
;	DECFSZ	TIMER1
;	GOTO	LP
;	RETLW	0X00
;	
;BIT1	NOP
;LP0	BSF	PORTA,0	;1	/4
;	DECFSZ	TIMER0
;	GOTO 	LP0
;	MOVLW	0X7F
;	MOVWF	TIMER0
;L;P1	NOP
;	DECFSZ	TIMER0	
;	GOTO	LP1
;	BCF	PORTA,0
;	MOVLW	0X7E
;	MOVWF	TIMER0
;L;P2	NOP
;	DECFSZ	TIMER0
;	GOTO	LP2
;	RETLW	0X00
;	
;B;IT0	BSF	PORTA,0	;50% DUTY CYCLE
;	DECFSZ	TIMER0
;	GOTO	BIT0
;	BCF	PORTA,0
;LP3	NOP
;	DECFSZ	TIMER0
;	GOTO	LP3
;	RETLW	0X00
;
	END
;DISPLAY PIC could be setup as a power on /hold/shutdown if inactive after x receive cycles
;using a Q before the 5 volt regulator.

